package com.sztzjy.digital_credit.controller;

import cn.hutool.core.util.IdUtil;
import com.sztzjy.digital_credit.annotation.AnonymousAccess;
import com.sztzjy.digital_credit.config.Constant;
import com.sztzjy.digital_credit.config.exception.handler.DigitalEconomyxception;
import com.sztzjy.digital_credit.entity.StuBreachOfContractTraining;
import com.sztzjy.digital_credit.entity.StuBreachOfContractTrainingExample;
import com.sztzjy.digital_credit.entity.dto.EducationAndBreachOfContractDTO;
import com.sztzjy.digital_credit.mapper.StuBreachOfContractTrainingMapper;
import com.sztzjy.digital_credit.util.ResultEntity;
import com.sztzjy.digital_credit.util.excel.FilePortUtil;
import com.sztzjy.digital_credit.util.excel.ImportExcelUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import javax.imageio.ImageIO;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.net.URLEncoder;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.UUID;

/**
 * @author tz
 * @date 2024/4/26 17:41
 */
@Api(tags = "实训任务")
@RestController
@RequestMapping("api/stu/trainingTask")
public class StuCreditPortraitTrainingController {
    @Resource
    StuBreachOfContractTrainingMapper trainingMapper;


    @ApiOperation("征信画像--个人情况与违约:学历与违约数据比较")
    @AnonymousAccess
    @PostMapping("/dataComparison")
    public ResultEntity dataComparison(@RequestBody List<EducationAndBreachOfContractDTO> contractDTOS){

        return new ResultEntity<>(HttpStatus.OK,"成功");
    }

    @ApiOperation("逾期记录--生成逾期证明")
    @AnonymousAccess
    @GetMapping("/generatePaperBackground")
    protected void doGet(HttpServletResponse response) throws IOException {
        response.setContentType("image/png");

        // 创建纸张背景图像
        BufferedImage paperBackground = new BufferedImage(1200, 400, BufferedImage.TYPE_INT_RGB);
        Graphics2D g2d = paperBackground.createGraphics();

        // 设置纸张背景颜色
        g2d.setColor(Color.WHITE);
        g2d.fillRect(0, 0, paperBackground.getWidth(), paperBackground.getHeight());

        // 设置字体样式
        Font font = new Font("SimSun", Font.PLAIN, 14);
        g2d.setFont(font);
        g2d.setColor(Color.BLACK);

        // 读取文本文件内容
        String textFilePath = "D:\\home\\text\\content.txt";
        List<String> lines = Files.readAllLines(Paths.get(textFilePath));

        // 计算文本的起始位置（这里简单地从上往下逐行绘制）
        int textY = 50; // 起始Y坐标，可以根据需要调整
        for (String line : lines) {
            g2d.drawString(line, 50, textY); // 起始X坐标设置为50，可以根据需要调整
            textY += g2d.getFontMetrics().getHeight(); // 更新Y坐标以绘制下一行
        }

        // 释放Graphics2D资源
        g2d.dispose();

        // 将图像写入到响应输出流中
        try (ByteArrayOutputStream baos = new ByteArrayOutputStream()) {
            ImageIO.write(paperBackground, "png", baos);
            byte[] imageBytes = baos.toByteArray();
            response.getOutputStream().write(imageBytes);
        }
    }
}
