package com.sztzjy.digital_credit.controller;


import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.ExcelWriter;
import com.alibaba.excel.enums.WriteDirectionEnum;
import com.alibaba.excel.support.ExcelTypeEnum;
import com.alibaba.excel.util.MapUtils;
import com.alibaba.excel.write.metadata.WriteSheet;
import com.alibaba.excel.write.metadata.fill.FillConfig;
import com.alibaba.excel.write.metadata.fill.FillWrapper;
import com.sztzjy.digital_credit.annotation.AnonymousAccess;
import com.sztzjy.digital_credit.entity.*;
import com.sztzjy.digital_credit.mapper.*;
import com.sztzjy.digital_credit.util.excel.FilePortUtil;

import com.sztzjy.digital_credit.util.file.IFileUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.apache.poi.util.IOUtils;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.io.ClassPathResource;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletResponse;
import javax.validation.constraints.NotBlank;
import java.io.*;
import java.net.URLEncoder;
import java.util.*;
import java.util.stream.Collectors;

import static jdk.nashorn.internal.runtime.regexp.joni.Config.log;

/**
 * @author 17803
 * @date 2024-04-16 9:47
 */

@Api(tags = "导出Excel")
@RestController
@RequestMapping("api/stu/enterprise/export")
public class StuExportToExcelController {

    @Autowired
    private StuFinancialStatementsMapper financialStatementsMapper;

    @Autowired
    private StuScoreModuleMapper scoreModuleMapper;

    @Autowired
    private IFileUtil iFileUtil;

    @Autowired
    private StuOperationAssetAnalysisModuleMapper operationAssetAnalysisModuleMapper;

    @Autowired
    private StuProfitAbilityMapper profitAbilityMapper;

    @Autowired
    private StuSolvencyMapper solvencyMapper;

    @Autowired
    private StuOperatingCapacityMapper operatingCapacityMapper;


    @Autowired
    private StuGrowthAbilityMapper growthAbilityMapper;

    @Autowired
    private StuDuPontAnalysisMapper duPontAnalysisMapper;



    @ApiOperation("财务指标")
    @GetMapping("/financialIndexExport")
    @AnonymousAccess
    public void financialIndexExport(HttpServletResponse response, @RequestParam("userId") String userId) {
        Map<String, Object> sheetMap = new HashMap<>();

        //盈利能力
        StuProfitAbilityExample profitAbilityExample = new StuProfitAbilityExample();
        profitAbilityExample.createCriteria().andUserIdEqualTo(userId);
        List<StuProfitAbility> profitAbilityList = profitAbilityMapper.selectByExample(profitAbilityExample);
        if (!profitAbilityList.isEmpty()){

            sheetMap.put("data1", profitAbilityList.get(0).getGrossMargin());
            sheetMap.put("data2", profitAbilityList.get(0).getReturnAssetRoa());
            sheetMap.put("data3", profitAbilityList.get(0).getReturnEquityRoe());
            sheetMap.put("data4", profitAbilityList.get(0).getNetOperatProfitMargin());
        }



        //偿债能力
        StuSolvencyExample solvencyExample = new StuSolvencyExample();
        solvencyExample.createCriteria().andUserIdEqualTo(userId);
        List<StuSolvency> stuSolvencyList = solvencyMapper.selectByExample(solvencyExample);
        if (!stuSolvencyList.isEmpty()){

            //与模板对应字段-值设置

            sheetMap.put("data5", stuSolvencyList.get(0).getCurrentRatio());
            sheetMap.put("data6", stuSolvencyList.get(0).getAssetLiabilityRatio());
            sheetMap.put("data7", stuSolvencyList.get(0).getEquityRatio());
            sheetMap.put("data8", stuSolvencyList.get(0).getEquityMultiplier());

            sheetMap.put("data9", stuSolvencyList.get(0).getQuickRatio());
            sheetMap.put("data10", stuSolvencyList.get(0).getCashRatio());
        }


        //营运能力
        StuOperatingCapacityExample operatingCapacityExample = new StuOperatingCapacityExample();
        operatingCapacityExample.createCriteria().andUserIdEqualTo(userId);
        List<StuOperatingCapacity> operatingCapacityList = operatingCapacityMapper.selectByExample(operatingCapacityExample);
        if (!operatingCapacityList.isEmpty()){

            //与模板对应字段-值设置
            sheetMap.put("data11", operatingCapacityList.get(0).getTotalAssetTurnover());
            sheetMap.put("data12", operatingCapacityList.get(0).getCurrentAssetTurnover());
            sheetMap.put("data13", operatingCapacityList.get(0).getAccountsReceivalTurnoverRate());
            sheetMap.put("data14", operatingCapacityList.get(0).getInventoryTurnoverRate());

        }


        //成长能力
        StuGrowthAbilityExample growthAbilityExample = new StuGrowthAbilityExample();
        growthAbilityExample.createCriteria().andUserIdEqualTo(userId);
        List<StuGrowthAbility> growthAbilityList = growthAbilityMapper.selectByExample(growthAbilityExample);
        if (!growthAbilityList.isEmpty()){

            //与模板对应字段-值设置
            sheetMap.put("data15", growthAbilityList.get(0).getYearGrowth());

        }

        //杜邦分析
        StuDuPontAnalysisExample duPontAnalysisExample = new StuDuPontAnalysisExample();
        duPontAnalysisExample.createCriteria().andUserIdEqualTo(userId);
        List<StuDuPontAnalysis> duPontAnalysisList = duPontAnalysisMapper.selectByExample(duPontAnalysisExample);
        if (!duPontAnalysisList.isEmpty()){

            //与模板对应字段-值设置
            sheetMap.put("data16", duPontAnalysisList.get(0).getNetOperatProfitMargin());
            sheetMap.put("data17", duPontAnalysisList.get(0).getTotalAssetTurnover());
            sheetMap.put("data18", duPontAnalysisList.get(0).getEquityMultiplier());
            sheetMap.put("data19", duPontAnalysisList.get(0).getNetPrifitMarginTotalAsset());
            sheetMap.put("data20", duPontAnalysisList.get(0).getReturnEquity());

        }


        ExcelWriter excelWriter = null;
        InputStream inputStream = null;
        ServletOutputStream outputStream = null;

        try {

            ClassPathResource classPathResource = new ClassPathResource("/template/财务指标.xls");
            inputStream = classPathResource.getInputStream();
            outputStream = response.getOutputStream();

            excelWriter = EasyExcel.write(outputStream).inMemory(Boolean.TRUE).withTemplate(inputStream).excelType(ExcelTypeEnum.XLS).build();
            WriteSheet writeSheet = EasyExcel.writerSheet().build();
            //FillConfig fillConfig = FillConfig.builder().forceNewRow(Boolean.TRUE).build();
            excelWriter.fill(sheetMap, writeSheet);


            String fileName = URLEncoder.encode("财务指标", "UTF-8").replaceAll("\\+", "%20");
            response.setContentType("application/vnd.ms-excel");
            response.setCharacterEncoding("utf-8");
            response.setHeader("Content-disposition", "attachment;filename*=utf-8''" + fileName + ".xls");
            excelWriter.finish();


        } catch (IOException e) {
            throw new RuntimeException(e);
        }finally {
            // 千万别忘记finish 会帮忙关闭流
            if (excelWriter != null) {
                excelWriter.finish();
            }
            //关闭流
            if (outputStream != null) {
                try {
                    outputStream.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            if (inputStream != null) {
                try {
                    inputStream.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
    }



    @AnonymousAccess
    @GetMapping("/generalViewExport")
    @ApiOperation("资产负债表")
    public void balanceSheet(HttpServletResponse response,@NotBlank @RequestParam   @ApiParam("资产负债表/现金流量表/利润表")  String module) {
//        //导出的表名
//        String title = IdUtil.simpleUUID();
        //表中第一行表头字段
        String[] headers = {"序号", "指标名称", "2023/12/31","2022/12/31","2021/12/31"};

        StuFinancialStatementsExample financialStatementsExample = new StuFinancialStatementsExample();
        financialStatementsExample.createCriteria().andModuleEqualTo(module);
        //实际数据结果集
        List<StuFinancialStatements> financialStatementsList = financialStatementsMapper.selectByExample(financialStatementsExample);


        //List<TchGeneralViewDTO> tchGeneralViewDTOS = userService.selectAllGeneralViewList(schoolId);

        //具体需要写入excel需要哪些字段，这些字段取自UserReward类，也就是上面的实际数据结果集的泛型
        List<String> listColumn = Arrays.asList("serialNumber", "indicatorName", "dateOne", "dateTwo","dateThree");
        try {
            FilePortUtil.exportExcel(response, module, headers, financialStatementsList, listColumn);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }



    @ApiOperation("Z计分模型")
    @GetMapping("/moduleBaseInfoForZExport")
    @AnonymousAccess
    public void moduleBaseInfoForZExport(HttpServletResponse response, @RequestParam("userId") String userId) {
        StuScoreModuleExample scoreModuleExample = new StuScoreModuleExample();
        scoreModuleExample.createCriteria().andUserIdEqualTo(userId);


        List<StuScoreModule> scoreModuleList = scoreModuleMapper.selectByExample(scoreModuleExample);
        if (scoreModuleList.isEmpty()) {
            return;
        }

        Map<String, Object> sheetMap = new HashMap<>();
        //与模板对应字段-值设置
        sheetMap.put("data1", scoreModuleList.get(0).getxOneFirst());
        sheetMap.put("data2", scoreModuleList.get(0).getxTwoFirst());
        sheetMap.put("data3", scoreModuleList.get(0).getxThreeFirst());
        sheetMap.put("data4", scoreModuleList.get(0).getxFourFirst());
        sheetMap.put("data5", scoreModuleList.get(0).getxFiveFirst());
        sheetMap.put("data6", scoreModuleList.get(0).getzSixFirst());

        ExcelWriter excelWriter = null;
        InputStream inputStream = null;
        ServletOutputStream outputStream = null;

        try {

            ClassPathResource classPathResource = new ClassPathResource("/template/Z计分模型.xls");
            inputStream = classPathResource.getInputStream();
            outputStream = response.getOutputStream();

            excelWriter = EasyExcel.write(outputStream).inMemory(Boolean.TRUE).withTemplate(inputStream).excelType(ExcelTypeEnum.XLS).build();
            WriteSheet writeSheet = EasyExcel.writerSheet().build();
            //FillConfig fillConfig = FillConfig.builder().forceNewRow(Boolean.TRUE).build();
            excelWriter.fill(sheetMap, writeSheet);


            String fileName = URLEncoder.encode("Z计分模型", "UTF-8").replaceAll("\\+", "%20");
            response.setContentType("application/vnd.ms-excel");
            response.setCharacterEncoding("utf-8");
            response.setHeader("Content-disposition", "attachment;filename*=utf-8''" + fileName + ".xlsx");
            excelWriter.finish();


        } catch (IOException e) {
            throw new RuntimeException(e);
        }finally {
            // 千万别忘记finish 会帮忙关闭流
            if (excelWriter != null) {
                excelWriter.finish();
            }
            //关闭流
            if (outputStream != null) {
                try {
                    outputStream.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            if (inputStream != null) {
                try {
                    inputStream.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }











    }




    @ApiOperation("营运资产分析模型")
    @GetMapping("/operationAssetAnalysisModuleExport")
    @AnonymousAccess
    public void operationAssetAnalysisModuleExport(HttpServletResponse response, @RequestParam("userId") String userId) {
        StuOperationAssetAnalysisModuleExample analysisModuleExample = new StuOperationAssetAnalysisModuleExample();
        analysisModuleExample.createCriteria().andUserIdEqualTo(userId);


        List<StuOperationAssetAnalysisModule> operationAssetAnalysisModuleList = operationAssetAnalysisModuleMapper.selectByExample(analysisModuleExample);
        if (operationAssetAnalysisModuleList.isEmpty()) {
            return;
        }

        Map<String, Object> sheetMap = new HashMap<>();
        //与模板对应字段-值设置
        sheetMap.put("data1", operationAssetAnalysisModuleList.get(0).getOperatAsset());
        sheetMap.put("data2", operationAssetAnalysisModuleList.get(0).getWorkCapital());
        sheetMap.put("data3", operationAssetAnalysisModuleList.get(0).getCurrentRatio());
        sheetMap.put("data4", operationAssetAnalysisModuleList.get(0).getQuickRatio());
        sheetMap.put("data5", operationAssetAnalysisModuleList.get(0).getShortTermDebtToEquityRatio());
        sheetMap.put("data6", operationAssetAnalysisModuleList.get(0).getEquityRatio());
        sheetMap.put("data7", operationAssetAnalysisModuleList.get(0).getEvaluationValue());
        sheetMap.put("data8", operationAssetAnalysisModuleList.get(0).getCreditLimit());

        ExcelWriter excelWriter = null;
        InputStream inputStream = null;
        ServletOutputStream outputStream = null;

        try {

            ClassPathResource classPathResource = new ClassPathResource("/template/营运资产分析模型.xls");
            inputStream = classPathResource.getInputStream();
            outputStream = response.getOutputStream();

            excelWriter = EasyExcel.write(outputStream).inMemory(Boolean.TRUE).withTemplate(inputStream).excelType(ExcelTypeEnum.XLS).build();
            WriteSheet writeSheet = EasyExcel.writerSheet().build();
            //FillConfig fillConfig = FillConfig.builder().forceNewRow(Boolean.TRUE).build();
            excelWriter.fill(sheetMap, writeSheet);


            String fileName = URLEncoder.encode("营运资产分析模型", "UTF-8").replaceAll("\\+", "%20");
            response.setContentType("application/vnd.ms-excel");
            response.setCharacterEncoding("utf-8");
            response.setHeader("Content-disposition", "attachment;filename*=utf-8''" + fileName + ".xls");
            excelWriter.finish();


        } catch (IOException e) {
            throw new RuntimeException(e);
        }finally {
            // 千万别忘记finish 会帮忙关闭流
            if (excelWriter != null) {
                excelWriter.finish();
            }
            //关闭流
            if (outputStream != null) {
                try {
                    outputStream.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            if (inputStream != null) {
                try {
                    inputStream.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }











    }





    @ApiOperation("学历与违约:导出Excel")
    @GetMapping("/getExcelByEducation")
    @AnonymousAccess
    public void getExcelByEducation(HttpServletResponse response, @RequestParam("userId") String userId) {

        iFileUtil.download(response,"/excel/学历与违约.xls");

    }





}
