package com.sztzjy.digital_credit.controller;

import com.sztzjy.digital_credit.annotation.AnonymousAccess;
import com.sztzjy.digital_credit.entity.StuOperationAssetAnalysisModule;
import com.sztzjy.digital_credit.entity.StuScoreModule;
import com.sztzjy.digital_credit.service.StuFinancialEarlyWarningService;
import com.sztzjy.digital_credit.util.ResultEntity;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.constraints.NotBlank;

/**
 * @author 17803
 * @date 2024-04-16 16:01
 */

@Api(tags = "财务预警")
@RestController
@RequestMapping("api/stu/enterprise/financialEarlyWarning")
public class StuFinancialEarlyWarningController {

    @Autowired
    private StuFinancialEarlyWarningService financialEarlyWarningService;

    @ApiOperation("Z计分模型")
    @GetMapping("getModuleBaseInfoForZ")
    @AnonymousAccess
    public ResultEntity getModuleBaseInfoForZ(@NotBlank String userId) {

        return financialEarlyWarningService.getModuleBaseInfoForZ(userId);

    }


    //只提交有值的字段，其他字段不用提交
    @ApiOperation("Z计分模型(自动保存)")
    @PostMapping("moduleBaseInfoForZByAutoSave")
    @AnonymousAccess
    public ResultEntity moduleBaseInfoForZByAutoSave(@RequestBody StuScoreModule scoreModule) {

        return financialEarlyWarningService.moduleBaseInfoForZByAutoSave(scoreModule);

    }


    @ApiOperation("Z计分模型(提交算分)")
    @PostMapping("moduleBaseInfoForZBySubCalculate")
    @AnonymousAccess
    public ResultEntity moduleBaseInfoForZBySubCalculate(@RequestBody StuScoreModule scoreModule) {

        return financialEarlyWarningService.moduleBaseInfoForZBySubCalculate(scoreModule);

    }




    @ApiOperation("营运资产分析模型全部数据")
    @GetMapping("getOperationAssetAnalysisModule")
    @AnonymousAccess
    public ResultEntity getOperationAssetAnalysisModule(@NotBlank String userId) {

        return financialEarlyWarningService.getOperationAssetAnalysisModule(userId);

    }

    //只提交有值的字段，其他字段不用提交
    @ApiOperation("营运资产分析模型(自动保存)")
    @PostMapping("operationAssetAnalysisModuleByAutoSave")
    @AnonymousAccess
    public ResultEntity operationAssetAnalysisModuleByAutoSave(@RequestBody StuOperationAssetAnalysisModule assetAnalysisModule) {

        return financialEarlyWarningService.operationAssetAnalysisModuleByAutoSave(assetAnalysisModule);

    }

    @ApiOperation("营运资产分析模型(提交算分)")
    @PostMapping("assetAnalysisModuleBySubCalculate")
    @AnonymousAccess
    public ResultEntity assetAnalysisModuleBySubCalculate(@RequestBody StuOperationAssetAnalysisModule analysisModule) {

        return financialEarlyWarningService.assetAnalysisModuleBySubCalculate(analysisModule);

    }


}
