package com.sztzjy.digital_credit.controller;

import com.sztzjy.digital_credit.annotation.AnonymousAccess;
import com.sztzjy.digital_credit.entity.StuCreditEnhanceMeasure;
import com.sztzjy.digital_credit.entity.StuRatingModel;
import com.sztzjy.digital_credit.entity.StuRatingResult;
import com.sztzjy.digital_credit.service.StuRateService;
import com.sztzjy.digital_credit.util.ResultEntity;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * @author 17803
 * @date 2024-04-17 10:28
 */

@Api(tags = "评级模型和评级结果")
@RestController
@RequestMapping("api/stu/rate")
public class StuRateController {

@Autowired
private StuRateService rateService;


    @ApiOperation("评级模型查询")
    @GetMapping("getRateInfo")
    @AnonymousAccess
    public ResultEntity getRateInfo( @RequestParam("userId") String userId){

        return rateService.getRateInfo(userId);

    }

    @ApiOperation("评级模型自动保存")
    @PostMapping("rateInfoBuAuto")
    @AnonymousAccess
    public ResultEntity rateInfoBuAuto( @RequestBody StuRatingModel ratingModel){

        return rateService.rateInfoBuAuto(ratingModel);

    }

    @ApiOperation("评级模型提交算分")
    @PostMapping("rateInfoBuSubCalculate")
    @AnonymousAccess
    public ResultEntity rateInfoBuSubCalculate( @RequestBody StuRatingModel ratingModel){

        return rateService.rateInfoBuSubCalculate(ratingModel);

    }



    @ApiOperation("评级结果查询")
    @GetMapping("getRateResultInfo")
    @AnonymousAccess
    public ResultEntity getRateResultInfo( @RequestParam("userId") String userId){

        return rateService.getRateResultInfo(userId);

    }


    @ApiOperation("评级结果自动保存")
    @PostMapping("rateResultByAutoSave")
    @AnonymousAccess
    public ResultEntity rateResultBuAutoSave( @RequestBody StuRatingResult ratingResult){

        return rateService.rateResultBuAutoSave(ratingResult);

    }


    @ApiOperation("评级结果提交算分")
    @PostMapping("rateResultBySubCalculate")
    @AnonymousAccess
    public ResultEntity rateResultBySubCalculate( @RequestBody StuRatingResult ratingResult){

        return rateService.rateResultBySubCalculate(ratingResult);

    }


    @ApiOperation("增信措施自动评分")
    @PostMapping("enhanceMeasureByAutoRating")
    @AnonymousAccess
    public ResultEntity enhanceMeasureByAutoRating(@RequestBody StuCreditEnhanceMeasure enhanceMeasure){

        return rateService.enhanceMeasureByAutoRating(enhanceMeasure);

    }

    @ApiOperation("企业征信:重新实训")
    @PostMapping("enterpriseRetraining")
    @AnonymousAccess
    public ResultEntity enterpriseRetraining(String userId){

        return rateService.enterpriseRetraining(userId);

    }






}
