package com.sztzjy.digital_credit.controller.tch;

import com.github.pagehelper.PageInfo;
import com.sztzjy.digital_credit.annotation.AnonymousAccess;
import com.sztzjy.digital_credit.entity.StuFinancialStatements;
import com.sztzjy.digital_credit.entity.TchAssessmentPoints;
import com.sztzjy.digital_credit.entity.dto.CaseDetailsDTO;
import com.sztzjy.digital_credit.service.TchCaseManagementService;
import com.sztzjy.digital_credit.util.ResultEntity;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.checkerframework.checker.units.qual.A;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import javax.validation.constraints.NotBlank;
import java.util.List;

/**
 * @author tz
 * @date 2024/4/17 15:16
 */
@Api(tags = "教师端--案例管理")
@RestController
@RequestMapping("api/tch/management")

public class TchCaseManagementController {

    @Resource
    TchCaseManagementService tchCaseManagementService;
    @ApiOperation("案例详情展示")
    @AnonymousAccess
    @GetMapping("/getCaseDetails")
    public ResultEntity<CaseDetailsDTO> getCaseDetails(@NotBlank @ApiParam("归属模块") String module){
        CaseDetailsDTO caseDetailsDTO=tchCaseManagementService.getCaseDetails(module);
        return new ResultEntity<>(HttpStatus.OK,"成功",caseDetailsDTO);
    }

    @ApiOperation("考核点--企业财务报表展示")
    @AnonymousAccess
    @GetMapping("/getFinancialStatements")
    public ResultEntity getFinancialStatements(@RequestParam(required = false) @ApiParam("归属模块") String module,
                                               @ApiParam("当前页") Integer index,
                                               @ApiParam("每页条数") Integer size){
        PageInfo<StuFinancialStatements> financialStatements=tchCaseManagementService.getFinancialStatements(module,index,size);
        return new ResultEntity<>(HttpStatus.OK,"成功",financialStatements);
    }


//    @ApiOperation("考核点--征信方案/措施展示")
//    @AnonymousAccess
//    @GetMapping("/getCreditReporting")
//    public ResultEntity getCreditReporting(@ApiParam("归属模块") String module){
//        PageInfo<StuFinancialStatements> financialStatements=tchCaseManagementService.getFinancialStatements(module,index,size);
//        return new ResultEntity<>(HttpStatus.OK,"成功",financialStatements);
//    }
}
