package com.sztzjy.digital_credit.entity;

import java.math.BigDecimal;
import java.util.Date;

import io.swagger.annotations.ApiModelProperty;
/**
 *
 * @author tz
 * stu_personal_debit_card_info
 */
public class StuPersonalDebitCardInfo {
    @ApiModelProperty("ID")
    private Integer id;

    @ApiModelProperty("发卡机构数")
    private Integer numberOfIssuingInstitutions;

    @ApiModelProperty("账户数")
    private Integer numberOfAccounts;

    @ApiModelProperty("授信总额")
    private BigDecimal totalCreditAmount;

    @ApiModelProperty("单家行最高授信额")
    private BigDecimal maximumCreditLimitForSingleBank;

    @ApiModelProperty("单家行最低授信额")
    private BigDecimal minimumCreditLimitForSingleBank;

    @ApiModelProperty("额度(已用/透支)")
    private BigDecimal limit;


    @ApiModelProperty("最近6个月平均使用/透支额度")
    private BigDecimal averageCreditLimitRecentlySixMonthsths;

    @ApiModelProperty("卡类型（贷记卡、准贷记卡）")
    private String cardType;

    @ApiModelProperty("用户ID")
    private String userId;

    @ApiModelProperty("创建时间")
    private Date creationTime;

    @ApiModelProperty("更新时间")
    private Date updateTime;

    @ApiModelProperty("提交状态")
    private Integer submitStatus;

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getNumberOfIssuingInstitutions() {
        return numberOfIssuingInstitutions;
    }

    public void setNumberOfIssuingInstitutions(Integer numberOfIssuingInstitutions) {
        this.numberOfIssuingInstitutions = numberOfIssuingInstitutions;
    }

    public Integer getNumberOfAccounts() {
        return numberOfAccounts;
    }

    public void setNumberOfAccounts(Integer numberOfAccounts) {
        this.numberOfAccounts = numberOfAccounts;
    }

    public BigDecimal getTotalCreditAmount() {
        return totalCreditAmount;
    }

    public void setTotalCreditAmount(BigDecimal totalCreditAmount) {
        this.totalCreditAmount = totalCreditAmount;
    }

    public BigDecimal getMaximumCreditLimitForSingleBank() {
        return maximumCreditLimitForSingleBank;
    }

    public void setMaximumCreditLimitForSingleBank(BigDecimal maximumCreditLimitForSingleBank) {
        this.maximumCreditLimitForSingleBank = maximumCreditLimitForSingleBank;
    }

    public BigDecimal getMinimumCreditLimitForSingleBank() {
        return minimumCreditLimitForSingleBank;
    }

    public void setMinimumCreditLimitForSingleBank(BigDecimal minimumCreditLimitForSingleBank) {
        this.minimumCreditLimitForSingleBank = minimumCreditLimitForSingleBank;
    }

    public BigDecimal getLimit() {
        return limit;
    }

    public void setLimit(BigDecimal limit) {
        this.limit = limit;
    }

    public BigDecimal getAverageCreditLimitRecentlySixMonthsths() {
        return averageCreditLimitRecentlySixMonthsths;
    }

    public void setAverageCreditLimitRecentlySixMonthsths(BigDecimal averageCreditLimitRecentlySixMonthsths) {
        this.averageCreditLimitRecentlySixMonthsths = averageCreditLimitRecentlySixMonthsths;
    }

    public String getCardType() {
        return cardType;
    }

    public void setCardType(String cardType) {
        this.cardType = cardType == null ? null : cardType.trim();
    }

    public String getUserId() {
        return userId;
    }

    public void setUserId(String userId) {
        this.userId = userId == null ? null : userId.trim();
    }

    public Date getCreationTime() {
        return creationTime;
    }

    public void setCreationTime(Date creationTime) {
        this.creationTime = creationTime;
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public Integer getSubmitStatus() {
        return submitStatus;
    }

    public void setSubmitStatus(Integer submitStatus) {
        this.submitStatus = submitStatus;
    }
}