package com.sztzjy.digital_credit.entity;

import java.math.BigDecimal;
import java.util.Date;

import io.swagger.annotations.ApiModelProperty;
/**
 *
 * @author tz
 * stu_personal_outstanding_loans_info
 */
public class StuPersonalOutstandingLoansInfo {
    @ApiModelProperty("ID")
    private Integer id;

    @ApiModelProperty("未结清贷款-贷款机构数")
    private Integer numberOfLoanInstitutions;

    @ApiModelProperty("未结清贷款-笔数")
    private Integer numberOfTransactions;

    @ApiModelProperty("未结清贷款-合同总额")
    private BigDecimal totalContractAmount;

    @ApiModelProperty("未结清贷款-余额")
    private BigDecimal balance;

    @ApiModelProperty("未结清贷款最近6个月平均应还款")
    private BigDecimal averageRepaymentDueRecentlySixMonths;

    @ApiModelProperty("未销户贷记卡-发卡机构数")
    private Integer creditCardNumberOfIssuingInstitutions;

    @ApiModelProperty("未销户贷记卡-账户数")
    private Integer creditCardNumberOfAccounts;

    @ApiModelProperty("未销户贷记卡-授信总额")
    private BigDecimal creditCardTotalCreditAmount;

    @ApiModelProperty("未销户贷记卡-单家行最高授信额")
    private BigDecimal creditCardMaximumCreditLimitBank;

    @ApiModelProperty("未销户贷记卡-单家行最低授信额")
    private BigDecimal creditCardMinimumCreditLimitBank;

    @ApiModelProperty("未销户贷记卡-已用额度")
    private BigDecimal creditCardUsedCreditLimit;

    @ApiModelProperty("未销户贷记卡-最近6个月平均使用额度")
    private BigDecimal creditCardSixMonthsths;

    @ApiModelProperty("未销户准贷记卡-发卡机构数")
    private Integer quasiCreditCardNumberOfIssuingInstitutions;

    @ApiModelProperty("未销户准贷记卡-账户数")
    private Integer quasiCreditCardNumberOfAccounts;

    @ApiModelProperty("未销户准贷记卡-授信总额")
    private BigDecimal quasiCreditCardTotalCreditAmount;

    @ApiModelProperty("未销户准贷记卡-单家行最高授信额")
    private BigDecimal quasiCreditCardLimitForSingleBank;

    @ApiModelProperty("未销户准贷记卡-单家行最低授信额")
    private BigDecimal quasiCreditCardMinimumCreditLimitForSingleBank;

    @ApiModelProperty("未销户准贷记卡-透支额度")
    private BigDecimal quasiCreditCardLineOfCredit;

    @ApiModelProperty("未销户准贷记卡-最近6个月平均透支余额")
    private BigDecimal quasiCreditCardSixMonths;

    @ApiModelProperty("对外担保信息-担保笔数")
    private Integer guaranteeNumberOfGuarantees;

    @ApiModelProperty("对外担保信息-担保金额")
    private BigDecimal guaranteeAmount;

    @ApiModelProperty("对外担保信息-担保本金余额")
    private BigDecimal guaranteedPrincipalBalance;

    @ApiModelProperty("创建时间")
    private Date creationTime;

    @ApiModelProperty("更新时间")
    private Date updateTime;

    @ApiModelProperty("用户ID")
    private String userId;

    @ApiModelProperty("提交状态")
    private Integer submitStatus;

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getNumberOfLoanInstitutions() {
        return numberOfLoanInstitutions;
    }

    public void setNumberOfLoanInstitutions(Integer numberOfLoanInstitutions) {
        this.numberOfLoanInstitutions = numberOfLoanInstitutions;
    }

    public Integer getNumberOfTransactions() {
        return numberOfTransactions;
    }

    public void setNumberOfTransactions(Integer numberOfTransactions) {
        this.numberOfTransactions = numberOfTransactions;
    }

    public BigDecimal getTotalContractAmount() {
        return totalContractAmount;
    }

    public void setTotalContractAmount(BigDecimal totalContractAmount) {
        this.totalContractAmount = totalContractAmount;
    }

    public BigDecimal getBalance() {
        return balance;
    }

    public void setBalance(BigDecimal balance) {
        this.balance = balance;
    }

    public BigDecimal getAverageRepaymentDueRecentlySixMonths() {
        return averageRepaymentDueRecentlySixMonths;
    }

    public void setAverageRepaymentDueRecentlySixMonths(BigDecimal averageRepaymentDueRecentlySixMonths) {
        this.averageRepaymentDueRecentlySixMonths = averageRepaymentDueRecentlySixMonths;
    }

    public Integer getCreditCardNumberOfIssuingInstitutions() {
        return creditCardNumberOfIssuingInstitutions;
    }

    public void setCreditCardNumberOfIssuingInstitutions(Integer creditCardNumberOfIssuingInstitutions) {
        this.creditCardNumberOfIssuingInstitutions = creditCardNumberOfIssuingInstitutions;
    }

    public Integer getCreditCardNumberOfAccounts() {
        return creditCardNumberOfAccounts;
    }

    public void setCreditCardNumberOfAccounts(Integer creditCardNumberOfAccounts) {
        this.creditCardNumberOfAccounts = creditCardNumberOfAccounts;
    }

    public BigDecimal getCreditCardTotalCreditAmount() {
        return creditCardTotalCreditAmount;
    }

    public void setCreditCardTotalCreditAmount(BigDecimal creditCardTotalCreditAmount) {
        this.creditCardTotalCreditAmount = creditCardTotalCreditAmount;
    }

    public BigDecimal getCreditCardMaximumCreditLimitBank() {
        return creditCardMaximumCreditLimitBank;
    }

    public void setCreditCardMaximumCreditLimitBank(BigDecimal creditCardMaximumCreditLimitBank) {
        this.creditCardMaximumCreditLimitBank = creditCardMaximumCreditLimitBank;
    }

    public BigDecimal getCreditCardMinimumCreditLimitBank() {
        return creditCardMinimumCreditLimitBank;
    }

    public void setCreditCardMinimumCreditLimitBank(BigDecimal creditCardMinimumCreditLimitBank) {
        this.creditCardMinimumCreditLimitBank = creditCardMinimumCreditLimitBank;
    }

    public BigDecimal getCreditCardUsedCreditLimit() {
        return creditCardUsedCreditLimit;
    }

    public void setCreditCardUsedCreditLimit(BigDecimal creditCardUsedCreditLimit) {
        this.creditCardUsedCreditLimit = creditCardUsedCreditLimit;
    }

    public BigDecimal getCreditCardSixMonthsths() {
        return creditCardSixMonthsths;
    }

    public void setCreditCardSixMonthsths(BigDecimal creditCardSixMonthsths) {
        this.creditCardSixMonthsths = creditCardSixMonthsths;
    }

    public Integer getQuasiCreditCardNumberOfIssuingInstitutions() {
        return quasiCreditCardNumberOfIssuingInstitutions;
    }

    public void setQuasiCreditCardNumberOfIssuingInstitutions(Integer quasiCreditCardNumberOfIssuingInstitutions) {
        this.quasiCreditCardNumberOfIssuingInstitutions = quasiCreditCardNumberOfIssuingInstitutions;
    }

    public Integer getQuasiCreditCardNumberOfAccounts() {
        return quasiCreditCardNumberOfAccounts;
    }

    public void setQuasiCreditCardNumberOfAccounts(Integer quasiCreditCardNumberOfAccounts) {
        this.quasiCreditCardNumberOfAccounts = quasiCreditCardNumberOfAccounts;
    }

    public BigDecimal getQuasiCreditCardTotalCreditAmount() {
        return quasiCreditCardTotalCreditAmount;
    }

    public void setQuasiCreditCardTotalCreditAmount(BigDecimal quasiCreditCardTotalCreditAmount) {
        this.quasiCreditCardTotalCreditAmount = quasiCreditCardTotalCreditAmount;
    }

    public BigDecimal getQuasiCreditCardLimitForSingleBank() {
        return quasiCreditCardLimitForSingleBank;
    }

    public void setQuasiCreditCardLimitForSingleBank(BigDecimal quasiCreditCardLimitForSingleBank) {
        this.quasiCreditCardLimitForSingleBank = quasiCreditCardLimitForSingleBank;
    }

    public BigDecimal getQuasiCreditCardMinimumCreditLimitForSingleBank() {
        return quasiCreditCardMinimumCreditLimitForSingleBank;
    }

    public void setQuasiCreditCardMinimumCreditLimitForSingleBank(BigDecimal quasiCreditCardMinimumCreditLimitForSingleBank) {
        this.quasiCreditCardMinimumCreditLimitForSingleBank = quasiCreditCardMinimumCreditLimitForSingleBank;
    }

    public BigDecimal getQuasiCreditCardLineOfCredit() {
        return quasiCreditCardLineOfCredit;
    }

    public void setQuasiCreditCardLineOfCredit(BigDecimal quasiCreditCardLineOfCredit) {
        this.quasiCreditCardLineOfCredit = quasiCreditCardLineOfCredit;
    }

    public BigDecimal getQuasiCreditCardSixMonths() {
        return quasiCreditCardSixMonths;
    }

    public void setQuasiCreditCardSixMonths(BigDecimal quasiCreditCardSixMonths) {
        this.quasiCreditCardSixMonths = quasiCreditCardSixMonths;
    }

    public Integer getGuaranteeNumberOfGuarantees() {
        return guaranteeNumberOfGuarantees;
    }

    public void setGuaranteeNumberOfGuarantees(Integer guaranteeNumberOfGuarantees) {
        this.guaranteeNumberOfGuarantees = guaranteeNumberOfGuarantees;
    }

    public BigDecimal getGuaranteeAmount() {
        return guaranteeAmount;
    }

    public void setGuaranteeAmount(BigDecimal guaranteeAmount) {
        this.guaranteeAmount = guaranteeAmount;
    }

    public BigDecimal getGuaranteedPrincipalBalance() {
        return guaranteedPrincipalBalance;
    }

    public void setGuaranteedPrincipalBalance(BigDecimal guaranteedPrincipalBalance) {
        this.guaranteedPrincipalBalance = guaranteedPrincipalBalance;
    }

    public Date getCreationTime() {
        return creationTime;
    }

    public void setCreationTime(Date creationTime) {
        this.creationTime = creationTime;
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getUserId() {
        return userId;
    }

    public void setUserId(String userId) {
        this.userId = userId == null ? null : userId.trim();
    }

    public Integer getSubmitStatus() {
        return submitStatus;
    }

    public void setSubmitStatus(Integer submitStatus) {
        this.submitStatus = submitStatus;
    }
}