package com.sztzjy.digital_credit.entity;

import java.math.BigDecimal;
import java.util.UUID;

import io.swagger.annotations.ApiModelProperty;
/**
 *
 * @author tz
 * tch_module_weith
 */
public class TchModuleWeith {
    @ApiModelProperty("模块权重ID")
    private Integer id;

    @ApiModelProperty("学校ID")
    private String schoolId;

    @ApiModelProperty("贷款案例权重")
    private BigDecimal loanCasesWeight;

    @ApiModelProperty("个人情况与违约权重")
    private BigDecimal perSituationWeiht;

    @ApiModelProperty("还款行为与违约权重")
    private BigDecimal repaymentBehaviorWeiht;

    @ApiModelProperty("个人征信-影响因素与分析权重")
    private BigDecimal perInfluenceFactorWeith;

    @ApiModelProperty("个人征信-征信优化与分析权重")
    private BigDecimal perCreditOptimizationWeith;

    @ApiModelProperty("个人征信-征信评级模型权重")
    private BigDecimal perCreditRatingWeith;

    @ApiModelProperty("企业征信-影响因素与分析权重")
    private BigDecimal entInfluenceFactorWeith;

    @ApiModelProperty("企业征信-征信优化与分析权重")
    private BigDecimal entCreditOptimizationWeith;

    @ApiModelProperty("企业征信-征信评级模型权重")
    private BigDecimal entCreditRatingWeith;

    @ApiModelProperty("案例-用户画像权重")
    private BigDecimal caseUserProfileWeith;

    @ApiModelProperty("案例-个人征信权重")
    private BigDecimal casePersonalCreditWeith;

    @ApiModelProperty("案例-企业征信权重")
    private BigDecimal caseCorporateCreditWeith;

    public TchModuleWeith(){

    }

    public TchModuleWeith(String schoolId){
        Integer uuid = UUID.randomUUID().toString().replaceAll("-", "").hashCode();
        uuid = uuid < 0 ? -uuid : uuid;//String.hashCode() 值会为空
        this.id=uuid;
        this.schoolId=schoolId;
        this.loanCasesWeight=BigDecimal.valueOf(0.4);
        this.perSituationWeiht=BigDecimal.valueOf(0.3);
        this.repaymentBehaviorWeiht=BigDecimal.valueOf(0.3);
        this.perInfluenceFactorWeith=BigDecimal.valueOf(0.3);
        this.perCreditOptimizationWeith=BigDecimal.valueOf(0.4);
        this.perCreditOptimizationWeith=BigDecimal.valueOf(0.3);
        this.entInfluenceFactorWeith=BigDecimal.valueOf(0.3);
        this.entCreditOptimizationWeith=BigDecimal.valueOf(0.4);
        this.entCreditOptimizationWeith=BigDecimal.valueOf(0.3);
        this.caseUserProfileWeith=BigDecimal.valueOf(0.4);
        this.casePersonalCreditWeith=BigDecimal.valueOf(0.3);
        this.caseCorporateCreditWeith=BigDecimal.valueOf(0.3);
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getSchoolId() {
        return schoolId;
    }

    public void setSchoolId(String schoolId) {
        this.schoolId = schoolId == null ? null : schoolId.trim();
    }

    public BigDecimal getLoanCasesWeight() {
        return loanCasesWeight;
    }

    public void setLoanCasesWeight(BigDecimal loanCasesWeight) {
        this.loanCasesWeight = loanCasesWeight;
    }

    public BigDecimal getPerSituationWeiht() {
        return perSituationWeiht;
    }

    public void setPerSituationWeiht(BigDecimal perSituationWeiht) {
        this.perSituationWeiht = perSituationWeiht;
    }

    public BigDecimal getRepaymentBehaviorWeiht() {
        return repaymentBehaviorWeiht;
    }

    public void setRepaymentBehaviorWeiht(BigDecimal repaymentBehaviorWeiht) {
        this.repaymentBehaviorWeiht = repaymentBehaviorWeiht;
    }

    public BigDecimal getPerInfluenceFactorWeith() {
        return perInfluenceFactorWeith;
    }

    public void setPerInfluenceFactorWeith(BigDecimal perInfluenceFactorWeith) {
        this.perInfluenceFactorWeith = perInfluenceFactorWeith;
    }

    public BigDecimal getPerCreditOptimizationWeith() {
        return perCreditOptimizationWeith;
    }

    public void setPerCreditOptimizationWeith(BigDecimal perCreditOptimizationWeith) {
        this.perCreditOptimizationWeith = perCreditOptimizationWeith;
    }

    public BigDecimal getPerCreditRatingWeith() {
        return perCreditRatingWeith;
    }

    public void setPerCreditRatingWeith(BigDecimal perCreditRatingWeith) {
        this.perCreditRatingWeith = perCreditRatingWeith;
    }

    public BigDecimal getEntInfluenceFactorWeith() {
        return entInfluenceFactorWeith;
    }

    public void setEntInfluenceFactorWeith(BigDecimal entInfluenceFactorWeith) {
        this.entInfluenceFactorWeith = entInfluenceFactorWeith;
    }

    public BigDecimal getEntCreditOptimizationWeith() {
        return entCreditOptimizationWeith;
    }

    public void setEntCreditOptimizationWeith(BigDecimal entCreditOptimizationWeith) {
        this.entCreditOptimizationWeith = entCreditOptimizationWeith;
    }

    public BigDecimal getEntCreditRatingWeith() {
        return entCreditRatingWeith;
    }

    public void setEntCreditRatingWeith(BigDecimal entCreditRatingWeith) {
        this.entCreditRatingWeith = entCreditRatingWeith;
    }

    public BigDecimal getCaseUserProfileWeith() {
        return caseUserProfileWeith;
    }

    public void setCaseUserProfileWeith(BigDecimal caseUserProfileWeith) {
        this.caseUserProfileWeith = caseUserProfileWeith;
    }

    public BigDecimal getCasePersonalCreditWeith() {
        return casePersonalCreditWeith;
    }

    public void setCasePersonalCreditWeith(BigDecimal casePersonalCreditWeith) {
        this.casePersonalCreditWeith = casePersonalCreditWeith;
    }

    public BigDecimal getCaseCorporateCreditWeith() {
        return caseCorporateCreditWeith;
    }

    public void setCaseCorporateCreditWeith(BigDecimal caseCorporateCreditWeith) {
        this.caseCorporateCreditWeith = caseCorporateCreditWeith;
    }
}