package com.sztzjy.digital_credit.service;

import com.sztzjy.digital_credit.entity.StuOperationAssetAnalysisModule;
import com.sztzjy.digital_credit.entity.StuScoreModule;
import com.sztzjy.digital_credit.util.ResultEntity;

/**
 * @author 17803
 * @date 2024-04-16 16:05
 * 财务预警
 */

public interface StuFinancialEarlyWarningService {

    /**
        * Z计分模型
        * @param userId
        * @return
    */

    ResultEntity getModuleBaseInfoForZ(String userId);

    /**
        * Z计分模型(自动保存)
        * @param scoreModule
        * @return
    */

    ResultEntity moduleBaseInfoForZByAutoSave(StuScoreModule scoreModule);

    /**
        * Z计分模型(提交算分)
        * @param scoreModule
        * @return
    */

    ResultEntity moduleBaseInfoForZBySubCalculate(StuScoreModule scoreModule);

    /**
        * 营运资产分析模型全部数据
        * @param userId
        * @return
    */

    ResultEntity getOperationAssetAnalysisModule(String userId);

    /**
        * 营运资产分析模型(自动保存)
        * @param assetAnalysisModule
        * @return
    */

    ResultEntity operationAssetAnalysisModuleByAutoSave(StuOperationAssetAnalysisModule assetAnalysisModule);

    /**
        * 营运资产分析模型(提交算分)
        * @param analysisModule
        * @return
    */

    ResultEntity assetAnalysisModuleBySubCalculate(StuOperationAssetAnalysisModule analysisModule);
}
