package com.sztzjy.digital_credit.service;

import com.itextpdf.text.pdf.parser.PathConstructionRenderInfo;
import com.sztzjy.digital_credit.entity.*;

/**
 * 个人征信信息录入业务层
 * @author tz
 * @date 2024/4/15 10:41
 */
public interface StuPersonalCreditReportingService {

    //个人信息
    StuPersonalInfo getPersonalInfo(String userId);

    void servePersonalInfo(StuPersonalInfo stuPersonalInfo);

    void submitPersonalInfo(StuPersonalInfo stuPersonalInfo,String module);

    //---------------------------------------------------------------------

    //信用记录

    //信用提示
    StuPersonalCreditReminderInfo getCreditReminder(String userId);

    void serveCreditReminder(StuPersonalCreditReminderInfo creditReminderInfo);

    void submitCreditReminder(StuPersonalCreditReminderInfo creditReminderInfo,String module);

    //逾期及违约信息概要
    StuPersonalDefaultInfo getOverdueInfo(String userId);

    void serveOverdueInfo(StuPersonalDefaultInfo stuPersonalDefaultInfo);

    void submitOverdueInfo(StuPersonalDefaultInfo stuPersonalDefaultInfo,String module);

    //授信及负债信息概要
    StuPersonalOutstandingLoansInfo getCreditGranting(String userId);

    void serveCreditGranting(StuPersonalOutstandingLoansInfo stuPersonalOutstandingLoansInfo);


    void submitCreditGranting(StuPersonalOutstandingLoansInfo stuPersonalOutstandingLoansInfo,String module);


    //---------------------------------------------------------------------

    //信用评分

    StuCreditScore getCreditScore(String userId);

    void serveCreditScore(StuCreditScore stuCreditScore);

    void submitCreditScore(StuCreditScore stuCreditScore,String module);


    //---------------------------------------------------------------------
    //重新实训
    void againTraining(String userId);

    boolean getSchedule(String userId);
}
