package com.sztzjy.digital_credit.service;

import com.sztzjy.digital_credit.entity.*;

import java.math.BigDecimal;

/**
 * 个人征信计分业务层
 * @author tz
 * @date 2024/4/15 15:16
 */
public interface StuPersonalCreditService {

    /**
     * 个人信息录入计分
     * @param stuPersonalInfo
     * @return
     */
    void personalInfoScoring(StuPersonalInfo stuPersonalInfo,String module);

    /**
     * 信用记录--信用提示录入计分
     * @param creditReminderInfo
     */
    void creditReminderInfoScoring(StuPersonalCreditReminderInfo creditReminderInfo,String module);


    /**
     * 信用记录--逾期及违约信息录入计分
     * @param stuPersonalDefaultInfo
     */
    void overdueInfoScoring(StuPersonalDefaultInfo stuPersonalDefaultInfo,String module);


    /**
     * 信用记录--授信及负债信息概要录入计分
     * @param stuPersonalOutstandingLoansInfo
     */
    void creditGrantingScoring(StuPersonalOutstandingLoansInfo stuPersonalOutstandingLoansInfo,String module);


    /**
     * 信用评分录入计分
     * @param stuCreditScore
     */
    void creditScoreScoring(StuCreditScore stuCreditScore,String module);


    void scoreEntry(String userId,String module,BigDecimal score);
}
