package com.sztzjy.digital_credit.service;

import com.sztzjy.digital_credit.entity.StuCreditEnhanceMeasure;
import com.sztzjy.digital_credit.entity.StuRatingModel;
import com.sztzjy.digital_credit.entity.StuRatingResult;
import com.sztzjy.digital_credit.util.ResultEntity;

/**
 * @author 17803
 * @date 2024-04-17 10:33
 */
public interface StuRateService {
    /**
        *评级模型查询
        * @param userId
        * @return
    */

    ResultEntity getRateInfo(String userId);

    /**
        * 评级模型自动保存
        * @param ratingModel
        * @return
    */

    ResultEntity rateInfoBuAuto(StuRatingModel ratingModel);

    /**
        * 评级模型提交算分
        * @param ratingModel
        * @return
    */

    ResultEntity rateInfoBuSubCalculate(StuRatingModel ratingModel);

    /**
        * 评级结果查询
        * @param userId
        * @return
    */

    ResultEntity getRateResultInfo(String userId);

    /**
        * 评级结果自动保存
        * @param ratingResult
        * @return
    */

    ResultEntity rateResultBuAutoSave(StuRatingResult ratingResult);

    /**
        * 评级结果提交算分
        * @param ratingResult
        * @return
    */

    ResultEntity rateResultBySubCalculate(StuRatingResult ratingResult);

    /**
        * 增信措施自动评分
        * @param enhanceMeasure
        * @return
    */

    ResultEntity enhanceMeasureByAutoRating(StuCreditEnhanceMeasure enhanceMeasure);

    /**
        * 企业征信:重新实训
        * @param userId
        * @return
    */

    ResultEntity enterpriseRetraining(String userId);


    //企业征信完成状态
    Boolean completionStatusOfEnterprise(String userId);


    void enterScoreWriteUserByUserId(Object obj,String module,String userId);
}
