package com.sztzjy.digital_credit.service.impl;/**
 * @author 17803
 * @date 2024-04-23 9:44
 */

import cn.hutool.core.util.IdUtil;
import com.sztzjy.digital_credit.entity.StuMachineLearning;
import com.sztzjy.digital_credit.entity.StuMachineLearningExample;
import com.sztzjy.digital_credit.mapper.StuMachineLearningMapper;
import com.sztzjy.digital_credit.service.StuExperimentTrainByCreditService;
import com.sztzjy.digital_credit.util.ResultEntity;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class StuExperimentTrainByCreditServiceImpl implements StuExperimentTrainByCreditService {


    @Autowired
    private StuMachineLearningMapper machineLearningMapper;


    /**
        * 前端校验数据（自动保存接口）
        * @param learning
        * @return
    */

    @Override
    public ResultEntity trainByPublicSave(StuMachineLearning learning) {

        StuMachineLearningExample machineLearningExample = new StuMachineLearningExample();
        machineLearningExample.createCriteria().andUserIdEqualTo(learning.getUserId()).andModuleEqualTo(learning.getModule());
        List<StuMachineLearning> machineLearningList = machineLearningMapper.selectByExample(machineLearningExample);

        if (!machineLearningList.isEmpty()) {

            if (machineLearningList.get(0).getSubState() == 1)
            {
                return new ResultEntity<>(HttpStatus.OK,"保存成功！");
            }

                //已经有数据
            StuMachineLearning machineLearning = machineLearningList.get(0);

            Integer id = machineLearning.getId();

            BeanUtils.copyProperties(learning,machineLearning);
            machineLearning.setId(id);

            machineLearningMapper.updateByPrimaryKeySelective(machineLearning);

            return new ResultEntity<>(HttpStatus.OK,"保存成功！");

        }else {

            //第一次保存
            learning.setId((int) IdUtil.getSnowflakeNextId());

            machineLearningMapper.insertSelective(learning);

            return new ResultEntity<>(HttpStatus.OK,"保存成功！");

        }

    }
}
