package com.sztzjy.digital_credit.service.impl;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.sztzjy.digital_credit.config.Constant;
import com.sztzjy.digital_credit.entity.StuFinancialStatements;
import com.sztzjy.digital_credit.entity.StuFinancialStatementsExample;
import com.sztzjy.digital_credit.entity.dto.CaseDetailsDTO;
import com.sztzjy.digital_credit.mapper.StuFinancialStatementsMapper;
import com.sztzjy.digital_credit.service.TchCaseManagementService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author tz
 * @date 2024/4/17 15:40
 */
@Service
public class TchCaseManagementServiceImpl implements TchCaseManagementService {
    @Resource
    StuFinancialStatementsMapper stuFinancialStatementsMapper;
    @Override
    public CaseDetailsDTO getCaseDetails(String module) {
        CaseDetailsDTO caseDetailsDTO=new CaseDetailsDTO();
        if(module.equals(Constant.PERSONAL_CREDIT)){
            caseDetailsDTO.setName(Constant.NAME);
            caseDetailsDTO.setUniqueIdentifier(Constant.IDENTIFICATION_NUMBER);
            caseDetailsDTO.setCaseDetails(Constant.CASE_DETAILS);
        }
        if(module.equals(Constant.CORPORATE_CREDIT)){
            caseDetailsDTO.setName(Constant.ANLIMINGCHENG);
            caseDetailsDTO.setUniqueIdentifier(Constant.XINYONGDAIMA);
            caseDetailsDTO.setCaseDetails(Constant.ANLIINFO);
        }
        return caseDetailsDTO;
    }

    @Override
    public PageInfo<StuFinancialStatements> getFinancialStatements(String module, Integer index, Integer size) {
        //开启分页
        PageHelper.startPage(index,size);
        StuFinancialStatementsExample example=new StuFinancialStatementsExample();
        example.setOrderByClause("serial_number asc");
        if(module==null){
            example.createCriteria().andModuleEqualTo("资产负债表");
        }else {
            example.createCriteria().andModuleEqualTo(module);
        }
        List<StuFinancialStatements> stuFinancialStatements = stuFinancialStatementsMapper.selectByExample(example);
        return new PageInfo<>(stuFinancialStatements);

    }
}
